diff -ruNp nginx-1.2.0/src/core/ngx_resolver.c nginx-1.2.0_zls/src/core/ngx_resolver.c
--- nginx-1.2.0/src/core/ngx_resolver.c	2012-03-22 19:57:18.000000000 +0800
+++ nginx-1.2.0_zls/src/core/ngx_resolver.c	2012-04-25 15:11:13.058515993 +0800
@@ -1419,6 +1419,14 @@ ngx_resolver_process_a(ngx_resolver_t *r
             return;
         }
 
+        if (name.len == 0) {
+            ngx_log_error(r->log_level, r->log, 0,
+                "zero-length cname in DNS response for %*s",
+                (size_t)rn->nlen, rn->name);
+
+            return;
+        }
+
         ngx_log_debug1(NGX_LOG_DEBUG_CORE, r->log, 0,
                        "resolver cname:\"%V\"", &name);
 